/*
Copyright Renaud GICQUEL 2009  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/

package extThopt;

import javax.swing.*;
import java.beans.*;
import java.awt.*;
import java.util.*;
import rg.thopt.*;
import rg.corps.*;
import java.io.*;

/**
 * Classe pour calculer un cycle  vapeur en rgime non-nominal
 * 
 * le modle de turbine est celui de Stodola, en version multi-tage
 *
 * @author Renaud GICQUEL
 */
public class PiloteGV_REP extends ExtPilot  implements optimization.Lmdif_fcn
{
	boolean isInitialized=false;
	boolean isBuilt=false;
	boolean debug=true;
	String[]composant,nomComposant,nomNozz;
    String turbineName="",boilerName,condenserName, evapSettings="", condSettings="";
    
    TechnoHx technoChaudiere;
    double DeltaHcond,Te,Tf,massFlow, DTsurch, DTssrefr, Aevap, Acond, AevapReel, AcondReel, Uevap, Ucond;
    double tauTurb, DeltaHevap, mCpmin, mCpmax, NUT,R,epsilon, AdesignChaudiere, AdesignCond, lambdaVol;
    
    double TamontCompr, PamontCompr, UAevap, UAcond,DeltaH0,T2,Tevap, Pevap,Vevap,Hevap,DeltaH_NH3, Teau, DHcompr,
    rotationSpeed, Pcond, mCpRefrigChaudiere, mCpRefrigCond, mCpCalopChaudiere, mCpCalopCond, Tcond, PVR;
    
	double a0_value=0.96, alpha_value=0.038, Kh=872.7969721981, Vs_value=0.0199, Tsurch, primaryFlow, eta_is;	
    
    PointThopt amontChaudiere, avalChaudiere, entreePrimaire, sortiePrimaire;
    
	String tab=new String("\t");
	String ligne=new String("\n");
    
    Corps fluideThermo;

	final ButtonGroup groupAlgorithm=new ButtonGroup();
	
	// epsmch is the machine precision
	static final double epsmch = 2.22044604926e-16;

	int nfev = 0;
	int njev = 0;
	int nfev2 = 0;
	int njev2 = 0;
     

	public PiloteGV_REP()
	{
		//{{INIT_CONTROLS
		setTitle("Pilote de gnrateur de vapeur");
		getContentPane().setLayout(null);
		setSize(660,590);
		setVisible(false);
		bInitialSettings.setText("Dimensionnement technologique");
		bInitialSettings.setActionCommand("load");
		getContentPane().add(bInitialSettings);
		bInitialSettings.setBounds(380,12,240,36);
		JLabel6.setText("Pression HP secondaire");
		getContentPane().add(JLabel6);
		JLabel6.setForeground(new java.awt.Color(102,102,153));
		JLabel6.setBounds(312,192,156,24);
		getContentPane().add(Pevap_value);
		Pevap_value.setBounds(480,192,100,24);
		Pevap_value.setSelectionColor(new java.awt.Color(204,204,255));
		Pevap_value.setSelectedTextColor(java.awt.Color.black);
		Pevap_value.setCaretColor(java.awt.Color.black);
		Pevap_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		JLabel4.setText("Circuit secondaire");
		JLabel4.setForeground(new java.awt.Color(102,102,153));
		JLabel4.setFont(new Font("Dialog", Font.BOLD, 16));
		getContentPane().add(JLabel4);
//		JLabel4.setForeground(java.awt.Color.red);
		JLabel4.setBounds(312,166,156,24);
		Pcond_value.setSelectionColor(new java.awt.Color(204,204,255));
		Pcond_value.setSelectedTextColor(java.awt.Color.black);
		Pcond_value.setCaretColor(java.awt.Color.black);
		Pcond_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		Pcond_value.setEditable(false);
		getContentPane().add(Pcond_value);
	//	Pcond_value.setBounds(180,360,120,24);
		AdesignCond_value.setSelectionColor(new java.awt.Color(204,204,255));
		AdesignCond_value.setSelectedTextColor(java.awt.Color.black);
		AdesignCond_value.setCaretColor(java.awt.Color.black);
		AdesignCond_value.setDisabledTextColor(new java.awt.Color(153,153,153));
	//	getContentPane().add(AdesignCond_value);
	//	AdesignCond_value.setBounds(480,96,100,24);
		JLabel5.setText("Circuit primaire");
		getContentPane().add(JLabel5);
		JLabel5.setFont(new Font("Dialog", Font.BOLD, 16));
		JLabel5.setForeground(new java.awt.Color(102,102,153));
		JLabel5.setBounds(312,60,156,24);
		bCalculate.setText("Simulation en non nominal  ");
		bCalculate.setActionCommand("Calculate ");
		getContentPane().add(bCalculate);
		bCalculate.setBounds(400,324,200,60);
		JLabel10.setText("Design settings");
	//	getContentPane().add(JLabel10);
		JLabel10.setForeground(java.awt.Color.blue);
		JLabel10.setFont(new Font("Dialog", Font.BOLD, 18));
		JLabel10.setBounds(12,12,553,25);
		UAcond_value.setSelectionColor(new java.awt.Color(204,204,255));
		UAcond_value.setSelectedTextColor(java.awt.Color.black);
		UAcond_value.setCaretColor(java.awt.Color.black);
		UAcond_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		UAcond_value.setEditable(false);
		getContentPane().add(UAcond_value);
//		UAcond_value.setBounds(480,60,100,24);
		JLabel12.setText("condenser UA");
		getContentPane().add(JLabel12);
//		JLabel12.setBounds(312,60,156,24);
		JLabel13.setText("Surface GV impose");
		getContentPane().add(JLabel13);
		JLabel13.setForeground(new java.awt.Color(102,102,153));
		JLabel13.setBounds(12,96,161,22);
		AdesignChaudiere_value.setSelectionColor(new java.awt.Color(204,204,255));
		AdesignChaudiere_value.setSelectedTextColor(java.awt.Color.black);
		AdesignChaudiere_value.setCaretColor(java.awt.Color.black);
		AdesignChaudiere_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(AdesignChaudiere_value);
		AdesignChaudiere_value.setBounds(180,96,100,24);
		JLabel14.setText("Dbit primaire");
		getContentPane().add(JLabel14);
		JLabel14.setBounds(312,96,156,24);
		primaryFlow_value.setSelectionColor(new java.awt.Color(204,204,255));
		primaryFlow_value.setSelectedTextColor(java.awt.Color.black);
		primaryFlow_value.setCaretColor(java.awt.Color.black);
		primaryFlow_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(primaryFlow_value);
		primaryFlow_value.setBounds(480,96,100,24);
		JLabel16.setText("Puissance GV");
		getContentPane().add(JLabel16);
		JLabel16.setForeground(java.awt.Color.red);
		JLabel16.setBounds(12,360,156,24);
		DeltaHevap_value.setSelectionColor(new java.awt.Color(204,204,255));
		DeltaHevap_value.setSelectedTextColor(java.awt.Color.black);
		DeltaHevap_value.setCaretColor(java.awt.Color.black);
		DeltaHevap_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		DeltaHevap_value.setEditable(false);
		getContentPane().add(DeltaHevap_value);
		DeltaHevap_value.setBounds(180,360,120,24);
		JLabel15.setText("UA GV");
		getContentPane().add(JLabel15);
		JLabel15.setBounds(12,60,156,24);
		UAevap_value.setSelectionColor(new java.awt.Color(204,204,255));
		UAevap_value.setSelectedTextColor(java.awt.Color.black);
		UAevap_value.setCaretColor(java.awt.Color.black);
		UAevap_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		UAevap_value.setEditable(false);
		getContentPane().add(UAevap_value);
		UAevap_value.setBounds(180,60,100,24);
		JLabel20.setForeground(new java.awt.Color(102,102,153));
		JLabel20.setText("Dbit secondaire");
		getContentPane().add(JLabel20);
		JLabel20.setBounds(312,228,156,24);
		massFlow_value.setSelectionColor(new java.awt.Color(204,204,255));
		massFlow_value.setSelectedTextColor(java.awt.Color.black);
		massFlow_value.setCaretColor(java.awt.Color.black);
		massFlow_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		massFlow_value.setEditable(true);
		getContentPane().add(massFlow_value);
		massFlow_value.setBounds(480,228,100,24);
		JLabel2.setText("Tin primaire (C)");
		getContentPane().add(JLabel2);
		JLabel2.setBounds(312,132,156,24);
		Tinprimaire_value.setText("5");
		Tinprimaire_value.setSelectionColor(new java.awt.Color(204,204,255));
		Tinprimaire_value.setSelectedTextColor(java.awt.Color.black);
		Tinprimaire_value.setCaretColor(java.awt.Color.black);
		Tinprimaire_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(Tinprimaire_value);
		Tinprimaire_value.setBounds(480,132,100,24);
//		JLabel3.setText("turbine power");
		getContentPane().add(JLabel3);
		JLabel3.setForeground(java.awt.Color.red);
		JLabel3.setBounds(324,432,156,24);
		tauTurb_value.setSelectionColor(new java.awt.Color(204,204,255));
		tauTurb_value.setSelectedTextColor(java.awt.Color.black);
		tauTurb_value.setCaretColor(java.awt.Color.black);
		tauTurb_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		tauTurb_value.setEditable(false);
//		getContentPane().add(tauTurb_value);
		tauTurb_value.setBounds(480,432,120,24);
		JLabel7.setText("DeltaH cond");
//		getContentPane().add(JLabel7);
		JLabel7.setForeground(java.awt.Color.red);
		JLabel7.setBounds(12,432,156,24);
		DeltaHcond_value.setSelectionColor(new java.awt.Color(204,204,255));
		DeltaHcond_value.setSelectedTextColor(java.awt.Color.black);
		DeltaHcond_value.setCaretColor(java.awt.Color.black);
		DeltaHcond_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		DeltaHcond_value.setEditable(false);
//		getContentPane().add(DeltaHcond_value);
		DeltaHcond_value.setBounds(180,432,120,24);
		JLabel8.setText("Simulation results");
//		getContentPane().add(JLabel8);
		JLabel8.setForeground(java.awt.Color.red);
		JLabel8.setFont(new Font("Dialog", Font.BOLD, 18));
		JLabel8.setBounds(12,324,553,25);
		JLabel9.setText("Surface GV calcule");
		getContentPane().add(JLabel9);
		JLabel9.setForeground(java.awt.Color.red);
//		JLabel9.setForeground(new java.awt.Color(102,102,153));
		JLabel9.setBounds(12,132,156,24);
		AcalculatedChaudiere_value.setSelectionColor(new java.awt.Color(204,204,255));
		AcalculatedChaudiere_value.setSelectedTextColor(java.awt.Color.black);
		AcalculatedChaudiere_value.setCaretColor(java.awt.Color.black);
		AcalculatedChaudiere_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		AcalculatedChaudiere_value.setEditable(false);
		getContentPane().add(AcalculatedChaudiere_value);
		AcalculatedChaudiere_value.setBounds(180,132,100,24);
		JLabel11.setText("calculated condenser area");
	//	getContentPane().add(JLabel11);
		JLabel11.setBounds(312,132,156,24);
		AcalculatedCond_value.setSelectionColor(new java.awt.Color(204,204,255));
		AcalculatedCond_value.setSelectedTextColor(java.awt.Color.black);
		AcalculatedCond_value.setCaretColor(java.awt.Color.black);
		AcalculatedCond_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		AcalculatedCond_value.setEditable(false);
	//	getContentPane().add(AcalculatedCond_value);
		AcalculatedCond_value.setBounds(480,132,100,24);
		JLabel17.setText("Efficiency");
	//	getContentPane().add(JLabel17);
		JLabel17.setForeground(java.awt.Color.red);
		JLabel17.setBounds(324,468,156,24);
		eff_value.setSelectionColor(new java.awt.Color(204,204,255));
		eff_value.setSelectedTextColor(java.awt.Color.black);
		eff_value.setCaretColor(java.awt.Color.black);
		eff_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		eff_value.setEditable(false);
	//	getContentPane().add(eff_value);
		eff_value.setBounds(480,468,120,24);
		JLabel1.setText("Tout secondaire (C)");
		getContentPane().add(JLabel1);
		JLabel1.setForeground(java.awt.Color.red);
		JLabel1.setBounds(12,432,156,24);
		Tout_GV_value.setText("560");
		Tout_GV_value.setSelectionColor(new java.awt.Color(204,204,255));
		Tout_GV_value.setSelectedTextColor(java.awt.Color.black);
		Tout_GV_value.setCaretColor(java.awt.Color.black);
		Tout_GV_value.setEditable(false);
	//	Tout_GV_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(Tout_GV_value);
		Tout_GV_value.setBounds(180,432,120,24);//480,228,100,24);
		oneStepAlgorithm.setText("one step algorithm");
		oneStepAlgorithm.setActionCommand("one step algorithm");
		getContentPane().add(oneStepAlgorithm);
		oneStepAlgorithm.setBounds(12,276,168,24);
		twoStepAlgorithm.setText("two steps algorithm");
		twoStepAlgorithm.setActionCommand("two steps algorithm");
		getContentPane().add(twoStepAlgorithm);
		twoStepAlgorithm.setBounds(204,276,168,24);
		jcheckReInitialize.setText("reinitialize");
		jcheckReInitialize.setActionCommand("reinitialize");
	//	getContentPane().add(jcheckReInitialize);
		jcheckReInitialize.setBounds(432,276,152,20);
		getContentPane().add(algorithmResults);
		algorithmResults.setBounds(192,324,222,26);
		JLabel18.setText("Pincement");
		getContentPane().add(JLabel18);
		JLabel18.setForeground(java.awt.Color.red);
		JLabel18.setBounds(12,396,144,24);
		pinch_value.setSelectionColor(new java.awt.Color(204,204,255));
		pinch_value.setSelectedTextColor(java.awt.Color.black);
		pinch_value.setCaretColor(java.awt.Color.black);
		pinch_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		pinch_value.setEditable(false);
		getContentPane().add(pinch_value);
		pinch_value.setBounds(180,396,120,24);
		getContentPane().add(JList1);
		JList1.setBounds(216,540,20,40);
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		bInitialSettings.addActionListener(lSymAction);
		bCalculate.addActionListener(lSymAction);
		//}}

		//{{INIT_MENUS
		//}}

		type="Pilote GV REP";
        groupAlgorithm.add(oneStepAlgorithm);
        groupAlgorithm.add(twoStepAlgorithm);
        oneStepAlgorithm.setSelected(true);
	}

    /**
    * returns the component type 
    **/
    public String getCompType(){
        return type;
    }
    
	public String getClassDescription(){
	    return "pilot for a steam generator\n\n\nauthor : R. Gicquel December 2019";
	}
    
    void setupProject(){
        //on rcupre ici les instances des transfos externes dont on a besoin
        //afin d'accder  leurs diffrents paramtres pour les calculs ultrieurs
        
  }
	
	public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
	super.setVisible(b);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets ins = getInsets();
		setSize(ins.left + ins.right + d.width, ins.top + ins.bottom + d.height);
		Component components[] = getContentPane().getComponents();
		for (int i = 0; i < components.length; i++)
			{
			Point p = components[i].getLocation();
			p.translate(ins.left, ins.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	// Used for addNotify check.
	boolean fComponentsAdjusted = false;

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
		Object object = event.getSource();
		if (object == PiloteGV_REP.this)
			Thrust_WindowClosing(event);
		}
	}

	void Thrust_WindowClosing(java.awt.event.WindowEvent event)
	{
		dispose();		 // dispose of the Frame.
	}
	//{{DECLARE_CONTROLS
	javax.swing.JButton bInitialSettings = new javax.swing.JButton();
	javax.swing.JLabel JLabel6 = new javax.swing.JLabel();
	javax.swing.JTextField Pevap_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JTextField Pcond_value = new javax.swing.JTextField();
	javax.swing.JTextField AdesignCond_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JButton bCalculate = new javax.swing.JButton();
	javax.swing.JLabel JLabel10 = new javax.swing.JLabel();
	javax.swing.JTextField UAcond_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel12 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel13 = new javax.swing.JLabel();
	javax.swing.JTextField AdesignChaudiere_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel14 = new javax.swing.JLabel();
	javax.swing.JTextField primaryFlow_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel16 = new javax.swing.JLabel();
	javax.swing.JTextField DeltaHevap_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel15 = new javax.swing.JLabel();
	javax.swing.JTextField UAevap_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JTextField massFlow_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JTextField Tinprimaire_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JTextField tauTurb_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel7 = new javax.swing.JLabel();
	javax.swing.JTextField DeltaHcond_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel8 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel9 = new javax.swing.JLabel();
	javax.swing.JTextField AcalculatedChaudiere_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel11 = new javax.swing.JLabel();
	javax.swing.JTextField AcalculatedCond_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel17 = new javax.swing.JLabel();
	javax.swing.JTextField eff_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel20 = new javax.swing.JLabel();
	javax.swing.JTextField Tout_GV_value = new javax.swing.JTextField();
	javax.swing.JRadioButton oneStepAlgorithm = new javax.swing.JRadioButton();
	javax.swing.JRadioButton twoStepAlgorithm = new javax.swing.JRadioButton();
	javax.swing.JCheckBox jcheckReInitialize = new javax.swing.JCheckBox();
	javax.swing.JLabel algorithmResults = new javax.swing.JLabel();
	javax.swing.JLabel JLabel18 = new javax.swing.JLabel();
	javax.swing.JTextField pinch_value = new javax.swing.JTextField();
	javax.swing.JList JList1 = new javax.swing.JList();
	//}}

	//{{DECLARE_MENUS
	//}}


	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == bInitialSettings)
				bInitialSettings_actionPerformed(event);
			else if (object == bCalculate)
				bCalculate_actionPerformed(event);
			
		}
	}

	public void init(){
		isInitialized=true;
		proj=getProjet();
		setupProject();

        //initialisations des PointThopt et des TechnoDesign 
        //attention : les noms des points et composants doivent tre exacts, sous peine de gnrer une erreur empchant le chargement des TechnoDesign
        amontChaudiere=new PointThopt(proj,"entree alimentaire");
        avalChaudiere=new PointThopt(proj,"sortie vapeur");
        entreePrimaire=new PointThopt(proj,"entree primaire");
        sortiePrimaire=new PointThopt(proj,"sortie primaire");
        fluideThermo=(rg.corps.Corps)avalChaudiere.lecorps;  
        
        //noms des composants
	    boilerName="GV";
        
	    //instanciation des TechnoDesign dans les classes externes
		technoChaudiere=new TechnoEvaporator(proj, boilerName, entreePrimaire, sortiePrimaire, amontChaudiere, avalChaudiere);
	    addTechnoVector(technoChaudiere);
	    
	    //initialisation des TechnoDesign dans Thermoptim
		setupTechnoDesigns(vTechno);
	}
	
	void bInitialSettings_actionPerformed(java.awt.event.ActionEvent event){
	    if(!isInitialized)init();//la premire fois, on initialise, car il faut un constructeur sans argument
	                            //pour instancier la classe par le RMI
	                            
        String[] args=new String[2];
        args[0]="project";
        args[1]="";
        Vector vProp=proj.getProperties(args);
        String flowUnit=(String)vProp.elementAt(0);
        if(!flowUnit.equals("kg/s")){
	        String msg = "Watch out! the flow rate unit should be\"kg/s\".\nYou may have discrepancies between your units \nand those used for heat exchanger design";
	        JOptionPane.showMessageDialog(this, msg);  
        }
        
	    //pour plus de sret, le test pourrait porter sur l'existence de l'changeur dans le projet
	    if(!boilerName.equals("")){//initialisation de la chaudire
            args=new String[2];
            args[0]="heatEx";
            args[1]=boilerName;
            vProp=proj.getProperties(args);
            Double f=(Double)vProp.elementAt(15);
            UAevap=f.doubleValue();
            String fluideChaud=(String)vProp.elementAt(0);            
            args[0]="process";
            args[1]=fluideChaud;
            vProp=proj.getProperties(args);
            f=(Double)vProp.elementAt(4);
            double DeltaH=-f.doubleValue();
            f=(Double)vProp.elementAt(3);
            primaryFlow=f.doubleValue();
            primaryFlow_value.setText(Util.aff_d(primaryFlow,2));            
            Tinprimaire_value.setText(Util.aff_d(entreePrimaire.T-273.15,2));
            
            amontChaudiere.getProperties();
            avalChaudiere.getProperties();
            DTsurch=avalChaudiere.DTsat;
            entreePrimaire.getProperties();
            sortiePrimaire.getProperties();
	        Tf=entreePrimaire.T;

            mCpCalopChaudiere=DeltaH/(entreePrimaire.T-sortiePrimaire.T);
            mCpRefrigChaudiere=DeltaH/(avalChaudiere.T-amontChaudiere.T);
            DeltaHevap=DeltaH;
            UAevap_value.setText(Util.aff_d(UAevap,4));
            Tout_GV_value.setText(Util.aff_d(avalChaudiere.T-273.15,2));
            Pevap_value.setText(Util.aff_d(avalChaudiere.P,2));
            
            massFlow=getProcessFlow(boilerName);
            massFlow_value.setText(Util.aff_d(massFlow,2));

            updateHx(boilerName, RECALCULATE, !UPDATE_UA, 0, !UPDATE_EPSI, 0, !UPDATE_DTMIN, 0);

	        
	        //initialisations du TechnoDesign
	        technoChaudiere.makeDesign();
	        AevapReel=Util.lit_d(technoChaudiere.ADesign_value.getText());
	        Uevap=technoChaudiere.UA/AevapReel;
	        AcalculatedChaudiere_value.setText(Util.aff_d(technoChaudiere.A,0));     
	        double pinch2=entreePrimaire.T-avalChaudiere.T;
	        if(technoChaudiere.DTmin<=pinch2){
				JLabel18.setText("Pincement median");
		        pinch_value.setText(Util.aff_d(technoChaudiere.DTmin,2));
	        }
	        else{
				JLabel18.setText("Pincement haut");
		        pinch_value.setText(Util.aff_d(pinch2,2));
	        }
	    }
	    
	}
	
	void bCalculate_actionPerformed(java.awt.event.ActionEvent event){
	    calculatePilot();
	}
	public void calculatePilot(){
	    if(!isInitialized)init();//la premire fois, on initialise, car il faut un constructeur sans argument
	                            //pour instancier la classe par le RMI
	    
	    
	    //mise en place d'une rampe de variation des valeurs
	    
	    avalChaudiere.getProperties();
        entreePrimaire.getProperties();
	    double AdesignChaudiereOld=AdesignChaudiere;
	    double PevapOld=avalChaudiere.P;
	    double massFlowOld=massFlow;
	    double entreePrimaireTOld=entreePrimaire.T;
	    double primaryFlowOld=primaryFlow;
	    UAevap=Util.lit_d(UAevap_value.getText());
	    double AdesignChaudiereTarget=Util.lit_d(AdesignChaudiere_value.getText());
	    double PevapTarget=Util.lit_d(Pevap_value.getText());
	    double massFlowTarget=Util.lit_d(massFlow_value.getText());
	    double entreePrimaireTTarget=Util.lit_d(Tinprimaire_value.getText())+273.15;
	    double primaryFlowTarget=Util.lit_d(primaryFlow_value.getText());
	    double nRampe=20;
	    for (int l=0;l<nRampe+1;l++){
	    	AdesignChaudiere=AdesignChaudiereOld+l*(AdesignChaudiereTarget-AdesignChaudiereOld)/nRampe;
	    	
//		    Pour la pression, on pourrait utiliser une variation gomtrique
	    	Pevap=PevapOld+l*(PevapTarget-PevapOld)/nRampe;
	        avalChaudiere.P=Pevap;
	        avalChaudiere.update(!UPDATE_T,UPDATE_P,!UPDATE_X);
	        avalChaudiere.getProperties();
	        
	        massFlow=massFlowOld+l*(massFlowTarget-massFlowOld)/nRampe;
			updateprocess("entree alimentaire", "Exchange",RECALCULATE,IS_SET_FLOW, UPDATE_FLOW, massFlow,  !UPDATE_ETA, 1);
	        
	        amontChaudiere.P=Pevap;
	        amontChaudiere.update(!UPDATE_T,UPDATE_P,!UPDATE_X);
	        amontChaudiere.getProperties();
	        
	        primaryFlow=primaryFlowOld+l*(primaryFlowTarget-primaryFlowOld)/nRampe;
			updateprocess("entree primaire", "Exchange",RECALCULATE,IS_SET_FLOW, UPDATE_FLOW, primaryFlow,  !UPDATE_ETA, 1);
	        
	        entreePrimaire.T=entreePrimaireTOld+l*(entreePrimaireTTarget-entreePrimaireTOld)/nRampe;
	        entreePrimaire.update(UPDATE_T,!UPDATE_P,!UPDATE_X);
	        entreePrimaire.getProperties();
	
		    if(debug)System.out.println("\nPevap: " + Pevap+"  massFlow: " + massFlow
		    		+"  primaryFlow: " + primaryFlow
		    		+"  entreePrimaire.T: " + NUT+"  AdesignChaudiere: " + AdesignChaudiere); 
		    
		    algorithmResults.setText("");
		    
			int m = 1;
			int n = 1;
		        
			double fvec[] = new double[m+1];
			double x[] = new double[n+1];
	    	int info[] = new int[2];
			int iflag[] = new int[2];

			if(false)x[1] = sortiePrimaire.T;
		    else x[1] = avalChaudiere.T;
	
		    double residu0;
			double residu1;
		        
	        fcn(m,n,x,fvec,iflag);
			residu0 = optimization.Minpack_f77.enorm_f77(m,fvec);
	
			nfev2 = 0;
			njev2 = 0;
	
			double epsi=0.0005;//prcision globale demande sur la convergence
	        double epsfcn = 1.e-6;//prcision calcul des diffrences finies
	        
	        if(twoStepAlgorithm.isSelected()){
	            epsi=0.01;
	        }
			
	        //appel modifi de lmdiff avec modification prcision calcul des diffrences finies
			optimization.Minpack_f77.lmdif2_f77(this, m, n, x, fvec, epsi, epsfcn, info);
			residu1 = optimization.Minpack_f77.enorm_f77(m,fvec);
			
			System.out.println(); 
			System.out.println(" Initial L2 norm of the residuals: " + residu0); 
	        System.out.println("Final L2 norm of the residuals: " + residu1);
	        System.out.println("Number of function evaluations: " + nfev);
	        System.out.println("Number of Jacobian evaluations: " + njev);
	        System.out.println("Info value: " + info[1]);
	        System.out.println("Final approximate solution: " + x[1] );
			System.out.println(); 
	
		    algorithmResults.setText("Algorithm precision: " + Util.aff_d(residu1,8));
	
	        if(twoStepAlgorithm.isSelected()){
	            epsi=0.00005;
	            epsfcn = 1.e-9;//prcision calcul des diffrences finies
	    		
	            //appel modifi de lmdiff avec modification prcision calcul des diffrences finies
			    optimization.Minpack_f77.lmdif2_f77(this, m, n, x, fvec, epsi, epsfcn, info);
			    residu1 = optimization.Minpack_f77.enorm_f77(m,fvec);
					
			    System.out.println(); 
			    System.out.println(" Initial L2 norm of the residuals: " + residu0); 
	            System.out.println("Final L2 norm of the residuals: " + residu1);
	            System.out.println("Number of function evaluations: " + nfev);
	            System.out.println("Number of Jacobian evaluations: " + njev);
	            System.out.println("Info value: " + info[1]);
	            System.out.println("Final approximate solution: " + x[1]  );
			    System.out.println(); /**/
		        algorithmResults.setText("Algorithm precision: " + Util.aff_d(residu1,8));
			}
	        eff_value.setText(Util.aff_d(-tauTurb/DeltaHevap,4));
	        DeltaHevap_value.setText(Util.aff_d(DeltaHevap,0));
	        massFlow_value.setText(Util.aff_d(massFlow,4));
	        Pevap_value.setText(Util.aff_d(Pevap,4));
	        Tout_GV_value.setText(Util.aff_d(avalChaudiere.T-273.15,2));
	        double pinch2=entreePrimaire.T-avalChaudiere.T;
	        if(technoChaudiere.DTmin<=pinch2){
				JLabel18.setText("Pincement median");
		        pinch_value.setText(Util.aff_d(technoChaudiere.DTmin,2));
	        }
	        else{
				JLabel18.setText("Pincement haut");
		        pinch_value.setText(Util.aff_d(pinch2,2));
	        }
	    }
	}
    
 	public void fcn(int m, int n, double x[], double fvec[], int iflag[]) {
		if (iflag[1]==1) this.nfev++;
		if (iflag[1]==2) this.njev++;
		
		//mise  jour des variables "physiques" pour une meilleure comprhension du code
		
		if(false){
			sortiePrimaire.T=x[1];
	        sortiePrimaire.update(UPDATE_T,!UPDATE_P,!UPDATE_X);
	        sortiePrimaire.getProperties();
	
	        DeltaHevap= (entreePrimaire.H-sortiePrimaire.H)*primaryFlow;
	        avalChaudiere.H=amontChaudiere.H+DeltaHevap/massFlow;
	        avalChaudiere.T=avalChaudiere.corps.lecorps.getT_from_hP(avalChaudiere.H,avalChaudiere.P);
	        // pour bien faire, il faudrait calculer X, ce qui peut se faire assez facilement
	        //et afficher un message si X<=1
	        avalChaudiere.update(UPDATE_T,!UPDATE_P,UPDATE_X);
	        avalChaudiere.getProperties();
		}
	    else 
		{
	    	//on borne suprieurement l'intervalle de recherche pour viter une divergence numrique
	    	if(x[1]>entreePrimaire.T)x[1]=entreePrimaire.T-0.1;
	    	
			avalChaudiere.T=x[1];
			avalChaudiere.update(UPDATE_T,!UPDATE_P,!UPDATE_X);
			avalChaudiere.getProperties();
			
	        DeltaHevap=(avalChaudiere.H-amontChaudiere.H)*massFlow;
	        sortiePrimaire.H=entreePrimaire.H-DeltaHevap/primaryFlow;
	        sortiePrimaire.T=avalChaudiere.corps.lecorps.getT_from_hP(sortiePrimaire.H,sortiePrimaire.P);
	        sortiePrimaire.update(UPDATE_T,!UPDATE_P,UPDATE_X);
	        sortiePrimaire.getProperties();
		}

        Vector vProp;
        Double f;
        
        
        
        
        
        
        mCpRefrigChaudiere=DeltaHevap/(avalChaudiere.T-amontChaudiere.T);
        mCpCalopChaudiere=DeltaHevap/(entreePrimaire.T-sortiePrimaire.T);
       
        double R=mCpRefrigChaudiere/mCpCalopChaudiere;
        if(mCpRefrigChaudiere<mCpCalopChaudiere) {
        	mCpmin=mCpRefrigChaudiere;
        }
        else {
        	mCpmin=mCpCalopChaudiere;
        	R=mCpCalopChaudiere/mCpRefrigChaudiere;
        }
        epsilon=(avalChaudiere.T-amontChaudiere.T)/(entreePrimaire.T-amontChaudiere.T);
       
        double NUT=Util.NUT_epsi(epsilon,R);
        UAevap=NUT*mCpmin;
         
        if(debug)System.out.println("\nDeltaHevap: " + DeltaHevap
	    		+"  mCpRefrigChaudiere: " + mCpRefrigChaudiere
	    		+"  mCpCalopChaudiere: " + mCpCalopChaudiere);
        if(debug)System.out.println("UAevap: " + UAevap+"  epsilon: " + epsilon+"  mCpmin: " + mCpmin
	    		+"  NUT: " + NUT+"  R: " + R
	    		); 
                    
 		//mises  jour du simulateur avant recalcul du TechnoDesign
		//on les excute 3 fois par scurit, mais ce n'est pas optimis
	    for(int j=0;j<3;j++)proj.calcThopt();
        updateHx(boilerName, RECALCULATE, UPDATE_UA, UAevap, !UPDATE_EPSI, 0, !UPDATE_DTMIN, 0);
        updateHx(boilerName, RECALCULATE, UPDATE_UA, UAevap, !UPDATE_EPSI, 0, !UPDATE_DTMIN, 0);
        updateHx(boilerName, RECALCULATE, UPDATE_UA, UAevap, !UPDATE_EPSI, 0, !UPDATE_DTMIN, 0);
            
        amontChaudiere.getProperties();
        avalChaudiere.getProperties();
        entreePrimaire.getProperties();
        sortiePrimaire.getProperties();
                    
	    technoChaudiere.makeDesign();	            
	    AcalculatedChaudiere_value.setText(Util.aff_d(technoChaudiere.A,0));
  	    
	    //calcul du rsidu
		fvec[1] = resAevap();

   }
    

    	double resAevap(){//renvoie le rsidu de la surface de l'vaporateur
        UAevap_value.setText(Util.aff_d(UAevap,4));
 	    AevapReel=technoChaudiere.A;
	    AcalculatedChaudiere_value.setText(Util.aff_d(AevapReel,0));
 	    double z= AevapReel-AdesignChaudiere; 	        
	    z= 2*z/(AevapReel+AdesignChaudiere);
	    if(debug)System.out.println("AevapReel: " + AevapReel + ", AdesignChaudiere "+   AdesignChaudiere);
	    if(debug)System.out.println("resAevap: " + z + ", UAevap "+  UAevap);
	    if(debug)System.out.println(); 
		
        return z;
 	    
    }


	public void readCompParameters(String ligne_data){
	    String value="";
	    value=Util.extr_value(ligne_data, "mCpRefrigChaudiere");
		if(!(value==null)){
		    mCpRefrigChaudiere=Util.lit_d(value);
	    }
	    value=Util.extr_value(ligne_data, "UAevap");
		if(!(value==null)){
		    UAevap=Util.lit_d(value);
	        UAevap_value.setText(Util.aff_d(UAevap,4));
	    }
	    value=Util.extr_value(ligne_data, "mCpCalopChaudiere");
		if(!(value==null)){
		    mCpCalopChaudiere=Util.lit_d(value);
	        AcalculatedChaudiere_value.setText(Util.aff_d(mCpCalopChaudiere,0));
	    }
	    value=Util.extr_value(ligne_data, "DeltaHevap");
		if(!(value==null)){
		    DeltaHevap=Util.lit_d(value);
	        DeltaHevap_value.setText(Util.aff_d(DeltaHevap,0));
	    }
	    value=Util.extr_value(ligne_data, "AdesignChaudiere");
		if(!(value==null)){
		    AdesignChaudiere=Util.lit_d(value);
	        AdesignChaudiere_value.setText(Util.aff_d(AdesignChaudiere,0));
	    }
	    value=Util.extr_value(ligne_data, "pinch");
		if(!(value==null)){
		    double pinch=Util.lit_d(value);
		    pinch_value.setText(Util.aff_d(pinch,2));
	    }
	    value=Util.extr_value3(ligne_data, "technoChaudiere");
		if(!(value==null)){
		    evapSettings=value;
		    if(technoChaudiere!=null)technoChaudiere.readCaract(value);
	    }
	}
	
    public String saveCompParameters(){
	    String h="mCpRefrigChaudiere="+Util.aff_d(mCpRefrigChaudiere)+tab  
	    +"UAevap="+Util.aff_d(UAevap)+tab
	    +"mCpCalopChaudiere="+Util.aff_d(mCpCalopChaudiere)+tab
	    +"DeltaHevap="+Util.aff_d(DeltaHevap)+tab
	    +"AdesignChaudiere="+AdesignChaudiere_value.getText()+tab
	    +"AcalculatedChaudiere="+AcalculatedChaudiere_value.getText()+tab	    
	    +"pinch="+pinch_value.getText()+tab	    
	    
	    +"#technoChaudiere="+technoChaudiere.saveCaract()+"#"+tab
	    ;
        return h;
    }
 	
    

}